%% 공동번역 성서 (1977) 
\LoadClass[12pt,b5paper,twoside]{oblivoir}

\RequirePackage{fapapersize}
%\setheadfoot{\headheight}{2em}
\usefapapersize{*,*,27mm,37mm,33mm,35mm}
\parindent1.5em

\hypersetup{hidelinks}

\sideparmargin{outer}

%\setobmainfont(TeX Gyre Termes)
\RequirePackage{libertine}
\setkomainfont(Noto Serif CJK KR)[FakeStretch=.96,Scale=MatchUppercase]
\setkosansfont(Noto Sans CJK KR Light)(Noto Sans CJK KR Medium)[Scale=MatchUppercase]
%\newfontfamily\propnamefont{UnGraphic.ttf}[Scale=MatchUppercase]

\RequirePackage{lettrine}
\RequirePackage[savepos]{zref}
\RequirePackage{xcolor}
\RequirePackage{adjustbox}

\renewcommand\thefootnote{{\color{blue}\ojaso{footnote}}}
\paragraphfootnotes
\renewcommand\footnoterule{}
\counterwithin*{footnote}{page}
\setlength{\footmarkwidth}{0em}
\setlength{\footmarksep}{1.8em}
\setlength{\footparindent}{0em}
\setfootins{\dimexpr.5em+\bigskipamount+\fill\relax}{\bigskipamount}
%\newcommand{\foottextfont}{\footnotesize}
 
\ExplSyntaxOn

\NewDocumentCommand \PropName { m }
{
	{\sffamily #1}
}

\NewDocumentCommand \typeBible { m }
{
%	\int_zero:N \l_xxposy_int
	\ior_open:Nn \g_tmpa_ior { #1 }
	\ior_map_inline:Nn \g_tmpa_ior
	{
		\typeset_a_verse:n { ##1 }
	}
	\ior_close:N \g_tmpa_ior
}

\NewDocumentEnvironment { typeText } { }
{
	\group_begin:
	\exp_last_unbraced:Nno\verbatimoutput{\jobname-temp.txt}
}
{
	\endverbatimoutput
	\group_end:
	
	\noindent \typeBible{\jobname-temp.txt}
}

\int_new:N \l_ch_int 
\int_new:N \l_vrs_int

\tl_new:N \l_versetitle_tl

%\bool_new:N \l_nomark_bool 
\tl_new:N \g_saveposy_tl
\int_zero_new:N \l_prev_int

\def\tinyCircmark{\adjustbox{raise=2.2pt}{\tiny$\circ$}\kern1pt}

\NewDocumentCommand \VerseMark { m }
{ 
	\str_case_e:nnF { #1 } 
	{ 
		{ * } { \P\; }
		{ | } { \ignorespaces }
		{ < } { \hspace*{1em} }
		{ > } { \hspace*{1em} \tinyCircmark }
	}
	{ \tinyCircmark #1 }
}

\int_new:N \l_theverse_int
\int_zero_new:N \l_xxposy_int
%\int_new:N \l_zzposy_int

\cs_new:Npn \typeset_a_verse:n #1
{
	\exp_args:NNx \tl_gset:Nn \g_saveposy_tl { \zposy{hereposy-\int_use:N \l_xxposy_int} }
	\int_incr:N \l_xxposy_int
	\tl_set:Nn \l_thisverse_tl { #1 }
%	\regex_extract_once:nVN { (.)(.)(.) } \l_thisverse_tl \l_tmpa_seq
%	\tl_set:Nf \l_tmpa_tl { \seq_item:Nn \l_tmpa_seq { 1 } }

	\seq_clear:N \l_tmpa_seq 
	\regex_extract_once:nVNTF { ([\d]+);([\d]+) } \l_thisverse_tl \l_tmpa_seq
	{
		\exp_args:NNx \int_set:Nn \l_tmpa_int { \seq_item:Nn \l_tmpa_seq { 2 } }
		\exp_args:NNx \int_set:Nn \l_tmpb_int { \seq_item:Nn \l_tmpa_seq { 3 } }
		\int_set:Nn \l_theverse_int { \l_tmpb_int }
	}
	{
		\int_set:Nn \l_tmpa_int { \l_ch_int }
		\int_set:Nn \l_tmpb_int { \l_theverse_int }
		\int_set:Nn \l_theverse_int { 0 }
	}
	
	\seq_clear:N \l_tmpa_seq
	\tl_clear:N \l_versetitle_tl
	\regex_extract_once:nnN { \[(.*)\] } { #1 } \l_tmpa_seq
	\tl_set:Nf \l_versetitle_tl { \seq_item:Nn \l_tmpa_seq { 1 } }

	\tl_if_empty:NF \l_versetitle_tl
	{ \par \bigskip \noindent {\sffamily\bfseries \l_versetitle_tl } \nopagebreak\\ }
	
	\int_compare:nF { \l_ch_int == \l_tmpa_int }
	{ 
	  \int_gset:Nn \l_ch_int { \l_tmpa_int }
	  \nopagebreak\vspace{-\baselineskip}
	  \exp_args:No \lettrine { \int_use:N \l_tmpa_int } {\phantom{a}}
	  \setcounter{booksectioncnt}{ \int_use:N \l_tmpa_int }
	  \addtocounter{booksectioncnt}{-1}
	  \refstepcounter{booksectioncnt}
	  \addcontentsline{toc}{section}{\protect\numberline{\thebooksectioncnt}\int_use:N \l_tmpa_int }
	}

	\regex_replace_once:nnN { ^(.*)\s([\d]+);([\d]+) } {  } \l_thisverse_tl
	\tl_if_empty:NF \l_versetitle_tl
	{
		\regex_replace_once:nnN { \[(.*)\]\s } { } \l_thisverse_tl
	}
	
	\tl_put_left:Nn \l_thisverse_tl { \VerseMark }
	\regex_replace_all:nnN { <(.*?)>\s } { \c{relax}\c{footnote} { \1 } } \l_thisverse_tl

	\int_set_eq:NN \l_prev_int \l_tmpb_int

	\dim_set:Nn \l_tmpa_dim {\g_saveposy_tl sp - \zposy{hereposy-\int_use:N \l_xxposy_int} sp}

	\int_compare:nTF { \l_theverse_int == 0 }
	{
%		\par 
		\zsaveposy{hereposy-\int_use:N \l_xxposy_int}
%		\indent
	}
	{
		\dim_compare:nTF { \l_tmpa_dim == \c_zero_dim }
		{
			\sidepar{
				\adjustbox{raise=-4pt}{\color{black!80}\tiny \int_use:N \l_tmpb_int }
%				\dim_eval:n { \zposx{hereposy-\int_use:N \l_xxposy_int } sp }
				}
		}
		{
			\sidepar{\adjustbox{raise=3pt}{\tiny\int_use:N \l_tmpb_int }}
		}
		\zsaveposy{hereposy-\int_use:N \l_xxposy_int}
	} 

	\regex_replace_all:nnN { \/\*(.+?)\*\/ } { \c{PropName}{\1} } \l_thisverse_tl
	\l_thisverse_tl
%	\bool_set_false:N \l_nomark_bool
	\markboth{\int_use:N \l_tmpa_int \c_colon_str \int_use:N \l_tmpb_int }
	{\int_use:N \l_tmpa_int \c_colon_str \int_use:N \l_tmpb_int }
	\markright{\int_use:N \l_tmpa_int \c_colon_str \int_use:N \l_tmpb_int }
}

%\NewDocumentCommand \novmark {}
%{
%	\bool_set_true:N \l_nomark_bool
%}

\NewDocumentCommand \Verse {}
{
	\group_begin:
	\renewcommand\tinyCircmark{}
	\par
	\begin{adjustwidth}{2em}{0pt}
	\parindent=0pt
}

\NewDocumentCommand \endVerse {}
{
	\end{adjustwidth}
	\group_end:
	\par
}


\newcommand*\BookName{}

\newcounter{booktitlecnt}
\newcounter{booksectioncnt}
\counterwithin{booksectioncnt}{booktitlecnt}

\NewDocumentCommand \MakeTitle {m}
{
	\medskip
	\refstepcounter{booktitlecnt}
	\int_zero:N \l_ch_int 
	\int_zero:N \l_vrs_int
	\renewcommand*\BookName{#1}
	\centerline{\bfseries\LARGE\BookName}\thispagestyle{empty}
	\addcontentsline{toc}{chapter}{\protect\numberline{\thebooktitlecnt}#1}
	\bigskip
}

\NewDocumentCommand \setChcounter { m }
{
	\int_set:Nn \l_ch_int { #1 }
}

\ExplSyntaxOff

\copypagestyle{psctb}{plain}
\makeoddhead{psctb}{\sffamily\thepage}{}{\hangulfontspec{UnGraphic.ttf}\small \BookName\  \leftmark}
\makeevenhead{psctb}{\hangulfontspec{UnGraphic.ttf}\small \BookName\ \rightmark}{}{\sffamily\thepage}
\makeoddfoot{psctb}{}{}{}
\makeevenfoot{psctb}{}{}{}

\AtBeginDocument{\pagestyle{psctb}}

